#ifndef _ARP2GTSP_H
#define _ARP2GTSP_H

/*
 * This header is used by almost all functions of the program. It defines 
 * macros and specifies data structures and function prototypes.
 */

#undef NDEBUG
#include <assert.h>
#include <ctype.h>
#include <float.h>
#include <limits.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

typedef struct Vertex Vertex;
typedef struct Wertex Wertex;
typedef struct Arc Arc;

struct Vertex {
    int Id, Required, Loc, Cost;
    int InDegree, OutDegree;
    Arc *FirstArc;
    Vertex *Dad;
};

struct Wertex {
    int Id, Cost;
    Vertex *From, *To;
    Wertex *Next;
};

struct Arc {
    int To, Cost, Required;
    Arc *Next;
};

#endif